Package org.optaplanner.core.impl.score.buildin.hardsoftlong

## Class HardSoftLongScoreHolderImpl

- java.lang.Object
- - org.optaplanner.core.impl.score.holder.AbstractScoreHolder<HardSoftLongScore>
  - - org.optaplanner.core.impl.score.buildin.hardsoftlong.HardSoftLongScoreHolderImpl

- All Implemented Interfaces:
    `HardSoftLongScoreHolder`, `ScoreHolder<HardSoftLongScore>`

      public final class HardSoftLongScoreHolderImpl
      extends AbstractScoreHolder<HardSoftLongScore>
      implements HardSoftLongScoreHolder

  See Also:
    `HardSoftLongScore`

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.optaplanner.core.impl.score.holder.AbstractScoreHolder

      `AbstractScoreHolder.BigDecimalMatchExecutor, AbstractScoreHolder.ConstraintActivationUnMatchListener, AbstractScoreHolder.IntMatchExecutor, AbstractScoreHolder.LongMatchExecutor, AbstractScoreHolder.ScoreMatchExecutor<Score_ extends AbstractScore<Score_>>`

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected long` | `hardScore` |
    `protected Map<org.kie.api.definition.rule.Rule,​AbstractScoreHolder.LongMatchExecutor>` | `matchExecutorByNumberMap` |
    `protected Map<org.kie.api.definition.rule.Rule,​AbstractScoreHolder.ScoreMatchExecutor<HardSoftLongScore>>` | `matchExecutorByScoreMap` | Slower than `matchExecutorByNumberMap`
    `protected long` | `softScore` |

    - ### Fields inherited from class org.optaplanner.core.impl.score.holder.AbstractScoreHolder

      `constraintMatchEnabled, constraintMatchTotalMap, EMPTY_OBJECT_ARRAY, indictmentMap, zeroScore`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `HardSoftLongScoreHolderImpl​(boolean constraintMatchEnabled)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addHardConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext, long hardWeight)` |
    `void` | `addMultiConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext, long hardWeight, long softWeight)` |
    `void` | `addSoftConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext, long softWeight)` |
    `void` | `configureConstraintWeight​(org.kie.api.definition.rule.Rule rule, HardSoftLongScore constraintWeight)` |
    `HardSoftLongScore` | `extractScore​(int initScore)` |
    `long` | `getHardScore()` |
    `long` | `getSoftScore()` |
    `void` | `impactScore​(org.kie.api.runtime.rule.RuleContext kcontext, int weightMultiplier, Object... justifications)` | For internal use only, use penalize() or reward() instead.
    `void` | `impactScore​(org.kie.api.runtime.rule.RuleContext kcontext, long weightMultiplier, Object... justifications)` | For internal use only, use penalize() or reward() instead.
    `void` | `impactScore​(org.kie.api.runtime.rule.RuleContext kcontext, Object... justifications)` | For internal use only, use penalize() or reward() instead.
    `void` | `impactScore​(org.kie.api.runtime.rule.RuleContext kcontext, BigDecimal weightMultiplier, Object... justifications)` | For internal use only, use penalize() or reward() instead.
    `void` | `penalize​(org.kie.api.runtime.rule.RuleContext kcontext)` | Penalize a match by the `ConstraintWeight` negated.
    `void` | `penalize​(org.kie.api.runtime.rule.RuleContext kcontext, long weightMultiplier)` | Penalize a match by the `ConstraintWeight` negated and multiplied with the weightMultiplier for all score levels.
    `void` | `penalize​(org.kie.api.runtime.rule.RuleContext kcontext, long hardWeightMultiplier, long softWeightMultiplier)` | Penalize a match by the `ConstraintWeight` negated and multiplied with the specific weightMultiplier per score level.
    `void` | `reward​(org.kie.api.runtime.rule.RuleContext kcontext)` | Reward a match by the `ConstraintWeight`.
    `void` | `reward​(org.kie.api.runtime.rule.RuleContext kcontext, long weightMultiplier)` | Reward a match by the `ConstraintWeight` multiplied with the weightMultiplier for all score levels.
    `void` | `reward​(org.kie.api.runtime.rule.RuleContext kcontext, long hardWeightMultiplier, long softWeightMultiplier)` | Reward a match by the `ConstraintWeight` multiplied with the specific weightMultiplier per score level.

    - ### Methods inherited from class org.optaplanner.core.impl.score.holder.AbstractScoreHolder

      `extractJustificationList, getConstraintMatchTotalMap, getIndictmentMap, impactScore, impactScore, impactScore, impactScore, isConstraintMatchEnabled, registerConstraintMatch`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.api.score.buildin.hardsoftlong.HardSoftLongScoreHolder

      `impactScore`

- - ### Field Detail

    - #### matchExecutorByNumberMap

          protected final Map<org.kie.api.definition.rule.Rule,​AbstractScoreHolder.LongMatchExecutor> matchExecutorByNumberMap

    - #### matchExecutorByScoreMap

          protected final Map<org.kie.api.definition.rule.Rule,​AbstractScoreHolder.ScoreMatchExecutor<HardSoftLongScore>> matchExecutorByScoreMap

      Slower than `matchExecutorByNumberMap`

    - #### hardScore

          protected long hardScore

    - #### softScore

          protected long softScore

  - ### Constructor Detail

    - #### HardSoftLongScoreHolderImpl

          public HardSoftLongScoreHolderImpl​(boolean constraintMatchEnabled)

  - ### Method Detail

    - #### getHardScore

          public long getHardScore()

    - #### getSoftScore

          public long getSoftScore()

    - #### configureConstraintWeight

          public void configureConstraintWeight​(org.kie.api.definition.rule.Rule rule,
                                                HardSoftLongScore constraintWeight)

      Overrides:
        `configureConstraintWeight` in class `AbstractScoreHolder<HardSoftLongScore>`

    - #### penalize

          public void penalize​(org.kie.api.runtime.rule.RuleContext kcontext)

      Description copied from interface: `ScoreHolder`
      Penalize a match by the `ConstraintWeight` negated.
      Specified by:
        `penalize` in interface `ScoreHolder<HardSoftLongScore>`
      Parameters:
        `kcontext` - never null, the magic variable in DRL

    - #### penalize

          public void penalize​(org.kie.api.runtime.rule.RuleContext kcontext,
                               long weightMultiplier)

      Description copied from interface: `HardSoftLongScoreHolder`
      Penalize a match by the `ConstraintWeight` negated and multiplied with the weightMultiplier for all score levels.
      Specified by:
        `penalize` in interface `HardSoftLongScoreHolder`
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `weightMultiplier` - at least 0

    - #### penalize

          public void penalize​(org.kie.api.runtime.rule.RuleContext kcontext,
                               long hardWeightMultiplier,
                               long softWeightMultiplier)

      Description copied from interface: `HardSoftLongScoreHolder`
      Penalize a match by the `ConstraintWeight` negated and multiplied with the specific weightMultiplier per score level. Slower than `HardSoftLongScoreHolder.penalize(RuleContext, long)`.
      Specified by:
        `penalize` in interface `HardSoftLongScoreHolder`
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `hardWeightMultiplier` - at least 0
        `softWeightMultiplier` - at least 0

    - #### reward

          public void reward​(org.kie.api.runtime.rule.RuleContext kcontext)

      Description copied from interface: `ScoreHolder`
      Reward a match by the `ConstraintWeight`.
      Specified by:
        `reward` in interface `ScoreHolder<HardSoftLongScore>`
      Parameters:
        `kcontext` - never null, the magic variable in DRL

    - #### reward

          public void reward​(org.kie.api.runtime.rule.RuleContext kcontext,
                             long weightMultiplier)

      Description copied from interface: `HardSoftLongScoreHolder`
      Reward a match by the `ConstraintWeight` multiplied with the weightMultiplier for all score levels.
      Specified by:
        `reward` in interface `HardSoftLongScoreHolder`
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `weightMultiplier` - at least 0

    - #### reward

          public void reward​(org.kie.api.runtime.rule.RuleContext kcontext,
                             long hardWeightMultiplier,
                             long softWeightMultiplier)

      Description copied from interface: `HardSoftLongScoreHolder`
      Reward a match by the `ConstraintWeight` multiplied with the specific weightMultiplier per score level. Slower than `HardSoftLongScoreHolder.reward(RuleContext, long)`.
      Specified by:
        `reward` in interface `HardSoftLongScoreHolder`
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `hardWeightMultiplier` - at least 0
        `softWeightMultiplier` - at least 0

    - #### impactScore

          public void impactScore​(org.kie.api.runtime.rule.RuleContext kcontext,
                                  Object... justifications)

      Description copied from class: `AbstractScoreHolder`
      For internal use only, use penalize() or reward() instead.
      Overrides:
        `impactScore` in class `AbstractScoreHolder<HardSoftLongScore>`
      Parameters:
        `kcontext` - never null
        `justifications` - the primary arguments(s) that the CS penalizes/rewards, not used outside of CS-D

    - #### impactScore

          public void impactScore​(org.kie.api.runtime.rule.RuleContext kcontext,
                                  int weightMultiplier,
                                  Object... justifications)

      Description copied from class: `AbstractScoreHolder`
      For internal use only, use penalize() or reward() instead.
      Specified by:
        `impactScore` in class `AbstractScoreHolder<HardSoftLongScore>`
      Parameters:
        `kcontext` - never null
        `weightMultiplier` - any
        `justifications` - the primary arguments(s) that the CS penalizes/rewards, not used outside of CS-D

    - #### impactScore

          public void impactScore​(org.kie.api.runtime.rule.RuleContext kcontext,
                                  long weightMultiplier,
                                  Object... justifications)

      Description copied from class: `AbstractScoreHolder`
      For internal use only, use penalize() or reward() instead.
      Specified by:
        `impactScore` in class `AbstractScoreHolder<HardSoftLongScore>`
      Parameters:
        `kcontext` - never null
        `weightMultiplier` - any
        `justifications` - the primary arguments(s) that the CS penalizes/rewards, not used outside of CS-D

    - #### impactScore

          public void impactScore​(org.kie.api.runtime.rule.RuleContext kcontext,
                                  BigDecimal weightMultiplier,
                                  Object... justifications)

      Description copied from class: `AbstractScoreHolder`
      For internal use only, use penalize() or reward() instead.
      Specified by:
        `impactScore` in class `AbstractScoreHolder<HardSoftLongScore>`
      Parameters:
        `kcontext` - never null
        `weightMultiplier` - any
        `justifications` - the primary arguments(s) that the CS penalizes/rewards, not used outside of CS-D

    - #### addHardConstraintMatch

          public void addHardConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext,
                                             long hardWeight)

      Specified by:
        `addHardConstraintMatch` in interface `HardSoftLongScoreHolder`
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `hardWeight` - higher is better, negative for a penalty, positive for a reward

    - #### addSoftConstraintMatch

          public void addSoftConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext,
                                             long softWeight)

      Specified by:
        `addSoftConstraintMatch` in interface `HardSoftLongScoreHolder`
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `softWeight` - higher is better, negative for a penalty, positive for a reward

    - #### addMultiConstraintMatch

          public void addMultiConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext,
                                              long hardWeight,
                                              long softWeight)

      Specified by:
        `addMultiConstraintMatch` in interface `HardSoftLongScoreHolder`
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `softWeight` - higher is better, negative for a penalty, positive for a reward

    - #### extractScore

          public HardSoftLongScore extractScore​(int initScore)

      Specified by:
        `extractScore` in class `AbstractScoreHolder<HardSoftLongScore>`